#!/usr/bin/perl -w

$dir = "/usr/local/cricket/nagios";

while (<>) {
  chomp;
  if ($_ !~ /^\[\d+\] SERVICE\;/) {
    next;
  }
  @_ = split /\;/,$_;
  $host = $_[1];
  $service = $_[2];
  $status = $_[31];
  if ($status =~ /^([A-Z])\:\\.*used.*\((\d+)\%\).*free.*\((\d+)\%\).*$/) {
    $hosts{$host}->{$service}->{'used'} = $2;
    $hosts{$host}->{$service}->{'free'} = $3;
    next;
  }
  if ($status =~ /^System Uptime.* (\d+) day.* (\d+) hour.* (\d+) minute.*$/) {
    $uptime = ($1*1440) + ($2*60) + $3;
    $hosts{$host}->{$service} = $uptime;
    next;
  }
  if ($status =~ /^CPU Load.*\(10 min\. (\d+)\).*$/) {
    $hosts{$host}->{$service} = $1;
    next;
  }
  if ($status =~ /^Memory usage.*used.*\((\d+)\%\).*free.*\((\d+)\%\).*$/) {
    $hosts{$host}->{$service}->{'used'} = $1;
    $hosts{$host}->{$service}->{'free'} = $2;
    next;
  }
}

foreach $h (keys %hosts) {
  if (defined $hosts{$h}->{"CPU Load"}) {
    $cpu = $hosts{$h}->{"CPU Load"};
  } else {
    $cpu = 100;
  }
  if (defined $hosts{$h}->{"System Uptime"}) {
    $uptime = $hosts{$h}->{"System Uptime"}
  } else {
    $uptime = 0;
  }
  if (defined $hosts{$h}->{"Memory usage"}) {
    $memused = $hosts{$h}->{"Memory usage"}->{'used'};
    $memfree = $hosts{$h}->{"Memory usage"}->{'free'};
  } else {
    $memused = 0;
    $memfree = 0;
  }
  open F,">$dir/host$h" || die "cannot open $dir/host$h: $!";
  print F "${cpu}\n${uptime}\n$memused\n$memfree\n";
  close F;
  foreach $s (%{$hosts{$h}}) {
    if ($s =~ /Disk ([A-Z])$/) {
      $disk = $1;
      open F,">$dir/disk$h-disks-$disk" || die "cannot open $dir/host$h: $!";
      $diskused = $hosts{$h}->{$s}->{'used'};
      $diskfree = $hosts{$h}->{$s}->{'free'};
      print F "$diskused\n$diskfree\n";
      close F;
    }
  }
}


